function [bayespic,bayesC,S] = BayesShrink(signal,levels,wv)

%Denoising using Bayes soft thresholding

%perform the wavelet decomposition until for levels given by levels

[C,S]=wavedec(signal,levels,wv);

st=S(1)+1;
bayesC=[C(1:st-1), zeros(1,length(st:1:length(C)))];

%Calculating sigmahat

sigmahat=median(abs(C(st:length(C))))/0.6745;

for j=2:length(S)-1
    
    coefh=C(st:st+S(j)-1);
    thr=bayes(coefh,sigmahat);
    bayesC(st:st+S(j)-1)=sthresh(coefh,thr);
    st=st+S(j);

end


%Reconstructing the signal from the Bayes-thresholded wavelet coefficients
bayespic=waverec(bayesC,S,wv);
