function [label] = labelNew(signal,prof,profmin,nbpoint)
%  we construct the label from depth profmin to depth prof, using nonlinear prediction 
%  and from depth 1 to profmin-1 using linear prediction, 
%  this is because the singularities may not appear at the finest scale

 [chain_line,Xint,V0] = labelingbis(signal,prof,profmin,nbpoint);
 ligne_cour = V0;
 
 for k = 1:profmin-1,
   ligne_cour = predictionL(ligne_cour); 
 end

 [chain_line_new,Xintnew,V0new] = labelingbis(ligne_cour,profmin,1,nbpoint);
 
 % we now have to concatenate the different chains
 chain_line_fin = cell(1,length(signal));
 Xintfin = [];
 
 for k=1:length(Xint)
    Y = chain_line{Xint(k)}(:)';
     for p=1:length(Xintnew)
      Z = chain_line_new{Xintnew(p)}(:)';
      if (Y(prof-profmin+1) == Z(1))
         chain_line_fin{Xint(k)} = [Y Z(2:end)]';
         Xintfin = [Xintfin Xint(k)];
         break;
      end   
    end
 end
 
 % Finally, we transform the chain_line into labels
 label = cell(1,nbpoint);
 for k=1:prof,
  Y = [];
  for p = 1:length(Xintfin)
   Y = [Y chain_line_fin{Xintfin(p)}(k)];
  end 
  label{prof-k+1} = Y;    
 end
end

