function [V] = reconstruct(MS,nbpoint,label)

% MS   : multiscale structure
% V    : reconstructed signal 
% prof : maximal depth of decomposition
 

 L      = length(MS);
 taille = log2(L);
 Venc   = cell(1,taille);
 
 taille_init = 2;
 %we put the data in a structure
 
 for j=1:taille-1, 
   if (j == 1)
    Venc{j}   = MS(1:taille_init);
    Venc{j+1} = MS(taille_init+1:2*taille_init);
   else
    Venc{j+1} = MS(taille_init+1:2*taille_init);
   end
   taille_init = 2*taille_init;
 end

 % reconstruction procedure 
 
 V = Venc{1};
 for j = taille:-1:nbpoint+1,
    V = predictionL(V);
    V(1:2:end-1) = V(1:2:end-1)+Venc{taille-j+2};
    V(2:2:end)   = V(2:2:end)-Venc{taille-j+2}; 
 end
  
 for j = nbpoint:-1:2,
    V = predictionNL(V,label{j});
    V(1:2:end-1) = V(1:2:end-1)+Venc{taille-j+2};
    V(2:2:end)   = V(2:2:end)-Venc{taille-j+2}; 
 end

 